/**
 * 
 */
import java.io.*;
import java.util.Random;



/**
 * @author verel
 *
 */
public class Main {

    /**
     * @param args
     */
    public static void main(String[] args) {
	if (args.length == 4) {
	    int n = Integer.parseInt(args[1]);

	    // maximum number of evaluation
	    int maxEval = Integer.parseInt(args[2]);

	    // initialization of the random numbers sequence
	    Random random = new Random(Integer.parseInt(args[3]));
    
	    // Evaluation function (oneMax)
	    OneMax eval = new OneMax(n);

	    // different possible search heuristics
	    Search search = null;

	    int selectSearch = Integer.parseInt(args[0]);

	    switch (selectSearch) {
		// random search
	    case 0: 
		search = new RandomSearch(random, eval);
		break;
		// random walk
	    case 1: 
		search = new RandomWalk(random, eval, maxEval);
		break;
		// hill-climbing
	    case 2: 
		search = new HillClimbingBest(random, eval, maxEval, eval.size());
		break;
		// first improvement
	    case 3: 
		search = new HillClimbingFirstImprovement(random, eval, maxEval, eval.size());
		break;
		// first improvement without replacement
	    case 4: 
		search = new HillClimbingFirstImprovementWithoutReplacement(random, eval, maxEval, eval.size());
		break;
	    }

	    // perform the search
	    search.run();

	    if (selectSearch == 1) {
		// print the random walk
		System.out.print(search);
	    } else {
		// print the number of evaluations
		System.out.println(search.nbEval() + " " + search.solution());
	    }

	} else {
	    System.out.println("4 arguments attendus : ");
	    System.out.println("premier argument: (0) random search, (1) random walk, (2) hill-climbing, (3) first-improvement, (4) first-improvement without replacement.");
	    System.out.println("Puis: longueur de la chaine de bits, nombre d'évaluation et la graine du générateur de nombres pseudo-aléatoires");
	}
    }


}
